<template>
  <GenericLayout>
    <template #header>
      <Header
        :back-button="true"
        :title="pageTitle"
      />
    </template>

    <template
      #page-content
    >
      <template v-if="isDesktopPlatform">
        <div
          class="page-title"
          v-if="pageTitle"
        >
          {{ pageTitle }}
        </div>
      </template>

      <q-card
        :square="!isDesktopPlatform"
        class="column no-wrap col"
      >
        <template v-if="loading">
          <q-card-section
            class="text-center"
          >
            <q-spinner-dots
              size="40px"
              color="primary"
            />
          </q-card-section>
        </template>

        <template v-else-if="fertilizationPlan">
          <!-- Result -->
          <q-card-section class="q-pa-none">
            <component
              v-if="hasResult"
              :is="algorithmResultsComponent.component"
              v-bind="algorithmResultsComponent.props"
            >
              <template #action-buttons>
                <!-- Action buttons -->
                <q-card-section>
                  <q-card-actions
                    vertical
                    align="stretch"
                    class="q-pa-none"
                  >
                    <template v-if="hasResult">
                      <q-btn
                        flat
                        text-color="primary"
                        :disable="!fertilizationPlan"
                        @click="onClickEdit"
                      >
                        <translate>Edit plan</translate>
                      </q-btn>
                    </template>
                    <template v-else>
                      <q-btn
                        color="primary"
                        :disable="!fertilizationPlan"
                        @click="onClickEdit"
                      >
                        <translate>Calculate results</translate>
                      </q-btn>
                    </template>
                    <q-btn
                      flat
                      text-color="primary"
                      :disable="!fertilizationPlan"
                      :loading="renaming"
                      @click="onClickRename"
                    >
                      <translate>Rename</translate>
                    </q-btn>
                    <q-btn
                      v-if="hasPDFExport"
                      flat
                      text-color="primary"
                      :loading="isProcessingPDF"
                      @click="onClickDownloadPDF"
                    >
                      <translate>Download as PDF</translate>
                    </q-btn>
                    <q-btn
                      flat
                      class="q-mt-lg"
                      text-color="red"
                      :disable="!fertilizationPlan"
                      :loading="deleting"
                      @click="onClickDelete"
                    >
                      <translate>Delete this plan</translate>
                    </q-btn>
                  </q-card-actions>
                </q-card-section>
              </template>
            </component>
          </q-card-section>
        </template>

        <template v-else>
          <q-card-section>
            <div class="text-subtitle1">
              <translate :translate-params="{fertilizationPlanId: $route.params.fertilizationPlanId}">
                Fertilization plan %{ fertilizationPlanId } not found
              </translate>
            </div>
            <q-btn
              color="primary"
              @click="onClickGoToFertilizationPlansPage"
              class="q-mt-md"
            >
              <translate>
                Go to the fertilization plans page
              </translate>
            </q-btn>
          </q-card-section>
        </template>
      </q-card>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { defineAsyncComponent } from 'vue'

import { PlatformMixin } from 'src/mixins/PlatformMixin'
import { DateMixin } from 'src/mixins/DateMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'
import MediaImage from 'src/components/MediaImage'
import FertilizationPlanMixin from 'src/pages/fieldbook/fertilization/mixins/FertilizationPlanMixin'
import FertilizationPlanPDFMixin from 'src/pages/fieldbook/fertilization/mixins/FertilizationPlanPDFMixin'
import { getTileLayerUrlTemplate } from 'src/services/map/layers/layer-factory'
import queryFertilizationPlanByPk from 'src/pages/fieldbook/fertilization/graphql/queryFertilizationPlanByPk'
import queryDefaultMapBaseLayer from 'src/pages/fieldbook/fertilization/graphql/queryDefaultMapBaseLayer'
import mutationDeleteFertilizationPlan from 'src/pages/fieldbook/fertilization/graphql/mutationDeleteFertilizationPlan'
import mutationUpdateFertilizationPlanName from 'src/pages/fieldbook/fertilization/graphql/mutationUpdateFertilizationPlanName'
import algorithms from 'src/services/fieldbook/fertilization/algorithms'

export default {
  name: 'FertilizationPlanPage',
  mixins: [
    PlatformMixin,
    DateMixin,
    FertilizationPlanMixin,
    FertilizationPlanPDFMixin
  ],
  components: {
    GenericLayout,
    Header,
    Footer,
    MediaImage,
    VegsystResultsCard: defineAsyncComponent(() => import('src/pages/fieldbook/fertilization/algorithms/vegsyst/components/VegsystResultsCard')),
    FertilicalcResults: defineAsyncComponent(() => import('src/pages/fieldbook/fertilization/algorithms/fertilicalc/components/FertilicalcResults')),
    VisioneResultsCard: defineAsyncComponent(() => import('src/pages/fieldbook/fertilization/algorithms/visione/components/VisioneResultsCard')),
    ArcResultsCard: defineAsyncComponent(() => import('src/pages/fieldbook/fertilization/algorithms/arc/components/ArcResultsCard')),
    RequafertiResultsCard: defineAsyncComponent(() => import('src/pages/fieldbook/fertilization/algorithms/requaferti/components/RequafertiResultsCard')),
    KalkulackyHnojenieResultsCard: defineAsyncComponent(() => import('src/pages/fieldbook/fertilization/algorithms/kalkulacky-hnojenie/components/KalkulackyHnojenieResultsCard')),
    NavigatorF3ResultsCard: defineAsyncComponent(() => import('src/pages/fieldbook/fertilization/algorithms/navigator-f3/components/NavigatorF3ResultsCard')),
    IcpaPmnResultsCard: defineAsyncComponent(() => import('src/pages/fieldbook/fertilization/algorithms/icpa-pmn/components/IcpaPmnResultsCard'))
  },
  data () {
    return {
      renaming: false,
      deleting: false,
      email: '',
      fertilizationPlan: null,
      defaultMapBaseLayer: null
    }
  },
  apollo: {
    fertilizationPlan: {
      query: queryFertilizationPlanByPk,
      notifyOnNetworkStatusChange: true,
      update: data => data.fertilization_plan_by_pk,
      variables () {
        return {
          id: this.$route.params.fertilizationPlanId
        }
      }
    },
    defaultMapBaseLayer: {
      query: queryDefaultMapBaseLayer,
      notifyOnNetworkStatusChange: true,
      update: data => data.map_base_layer[0]
    }
  },
  computed: {
    hasResult () {
      return Object.keys(this.fertilizationPlan?.results) !== null
    },
    loading () {
      return !this.fertilizationPlan && this.$apollo.queries.fertilizationPlan.loading
    },
    pageTitle () {
      if (this.fertilizationPlan) {
        return this.fertilizationPlan.name || this.fertilizationPlan.plot?.name
      } else {
        return '...'
      }
    },
    algorithmResultsComponent () {
      if (!this.fertilizationPlan) {
        return null
      } else {
        let algorithmId
        try {
          algorithmId = this.fertilizationPlan.algorithm.id
          const algorithm = algorithms[algorithmId]
          return {
            component: algorithm.resultComponent,
            props: {
              fertilizationPlanParameters: this.fertilizationPlan.parameters,
              fertilizationPlanResults: this.fertilizationPlan.results,
              displayActionButtons: false
            }
          }
        } catch (e) {
          console.error('Could not get result component for algorithmId ' + algorithmId, e)
          return null
        }
      }
    },
    hasPDFExport () {
      const algorithmId = this.fertilizationPlan?.algorithm?.id
      const algorithm = algorithms[algorithmId]
      return algorithm?.pdf
    }
  },
  methods: {
    async onClickEdit () {
      await this.$store.dispatch('fertilizationPlan/reset')
      // Set fertilization plan name and Id
      this.$store.commit('fertilizationPlan/setFertilizationPlanIdAndName', { ...this.fertilizationPlan })
      // Set algorithm
      this.$store.commit('fertilizationPlan/setAlgorithm', { ...this.fertilizationPlan.algorithm })
      // Set target
      this.$store.commit('fertilizationPlan/setTarget', { ...this.fertilizationPlan.plot })
      // Set parameters
      this.$store.commit('fertilizationPlan/setParameters', typeof this.fertilizationPlan.parameters === 'string' ? JSON.parse(this.fertilizationPlan.parameters) : this.fertilizationPlan.parameters)
      // Set results
      this.$store.commit('fertilizationPlan/setResults', typeof this.fertilizationPlan.results === 'string' ? JSON.parse(this.fertilizationPlan.results) : this.fertilizationPlan.results)
      // Set edition mode
      this.$store.commit('fertilizationPlan/setIsEdition', true)
      // go to the plot selection page
      const plotId = this.fertilizationPlan.plot?.id
      this.$router.push({
        name: 'fertilizationPlanPlotSelection',
        query: plotId != null ? { plotId } : null
      })
    },
    onClickDelete () {
      this.$q.dialog({
        title: this.$gettext('Delete'),
        message: `${this.$gettext('Are you sure you want to permanently delete this plan?')} (${this.fertilizationPlan.name})`,
        cancel: true,
        color: 'red'
      }).onOk(async () => {
        this.deleting = true
        try {
          await this.$apollo.mutate({
            mutation: mutationDeleteFertilizationPlan,
            variables: {
              fertilization_plan_id: this.fertilizationPlan.id
            }
          })
          this.$q.notify({
            message: this.$gettext('The plan has been successfully deleted.'),
            color: 'green'
          })
        } catch (e) {
          this.$q.notify({
            message: this.$gettext('There was an error while deleting the plan.'),
            color: 'red'
          })
        } finally {
          this.deleting = false
          this.$router.back()
        }
      })
    },
    onClickGoToFertilizationPlansPage () {
      this.$router.push({ name: 'fertilizationPlans' })
    },
    onClickRename () {
      this.$q.dialog({
        title: this.$gettext('Rename'),
        message: this.$gettext('Enter a new name:'),
        prompt: {
          model: this.fertilizationPlan.name,
          isValid: val => val && val.length > 3,
          type: 'text'
        },
        cancel: true
      }).onOk(async data => {
        this.renaming = true
        try {
          await this.$apollo.mutate({
            mutation: mutationUpdateFertilizationPlanName,
            variables: {
              fertilization_plan_id: this.fertilizationPlan.id,
              name: data
            }
          })
          this.$q.notify({
            color: 'green',
            message: this.$gettext('The plan has been successfully renamed.')
          })
        } catch (e) {
          this.$q.notify({
            color: 'red',
            message: this.$gettext('There was an error while renaming the plan.')
          })
        } finally {
          this.renaming = false
        }
      })
    },
    async onClickDownloadPDF () {
      this.downloadPDF(
        this.fertilizationPlan?.algorithm?.id,
        this.getDownloadPDFInputs(
          this.fertilizationPlan,
          getTileLayerUrlTemplate(this.defaultMapBaseLayer)
        ),
        this.fertilizationPlan?.name
      )
    }
  }
}
</script>
